#pragma once

#include "types.h"
#include <windows.h>


enum
{
	FILE_ERR__NONE,
	FILE_ERR__OUT_OF_MEMORY,
	FILE_ERR__UNSPECIFIED_OPEN_ERROR,
	FILE_ERR__NO_FILE,
	FILE_ERR__NO_ACCESS,
	FILE_ERR__CLOSE_ERROR,
	FILE_ERR__READ_FAULT,
// file ended
	FILE_ERR__INCOMPLETE_READ,
//	FILE_ERR__FILE_ENDED,
	FILE_ERR__WRITE_FAULT,
	FILE_ERR__DISK_FULL,
	FILE_ERRS_NUM
};


class File
{
private:
	void GetError ();
public:
	bool Open (bool write, bool widechar, const void* filepath);
	bool Close ();
	bool GetSize ();
	bool GetTime (FILETIME& ft);
	bool SetTime (FILETIME& ft);
	bool IsNotEOF (bool& is_not_eof);
	bool SetPointer (bool from_current, u64 pos);
	bool Read (void* buf, u32 len);
	bool Write (void* buf, u32 len);

private:
// sequence check helper
//	bool m_is_opened;
// *helper
	bool m_write;
	HANDLE m_hfile;
public:
	bool m_is_opened;
	u32 m_error;
	u64 m_len;
};

